<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card>
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading && hasWorks">
      <div v-if="isLecturer">
        <works-filter @change-filter="setFilters"></works-filter>
      </div>
      <ul>
        <work-item
            v-for="work in filteredWorks.length"
            :key="filteredWorks[work - 1]['uuId']"
            :id="filteredWorks[work - 1]['id']"
            :is-student="isStudent"
            :is-lecturer="isLecturer"
        >
        </work-item>
      </ul>
    </div>
    <div v-if="!isLoading && filteredWorks.length === 0">
      <h1>Nie dodano żadnej pracy zaliczeniowej.</h1>
    </div>
    <div v-if="isLecturer" class="button">
      <base-button mode="outline" link to="/addWork"
      >Dodaj pracę zaliczeniową
      </base-button>
    </div>
  </base-card>
</template>

<script setup>
import WorkItem from "@/components/WorkItem.vue";
import WorksFilter from "@/components/WorksFilter.vue";
import {ref, onMounted, computed} from "vue";
import { useStore } from "vuex";

const isLoading = ref(false);
const error = ref(null);
const activeFilters = ref({
  beforeDeadline: true,
  afterDeadline: true,
});

const store = useStore();

async function loadData() {
  isLoading.value = true;
  try {
    await store.dispatch("loadData");
  } catch (er) {
    error.value = er.message || "Nie udało się załadować prac zaliczeniowych.";
  }
  isLoading.value = false;
}

function handleError() {
  error.value = null;
}
function setFilters(updatedFilters) {
  activeFilters.value = updatedFilters;
}

const isLecturer = computed(function () {
  const roles = store.getters.roles;
  return roles.includes("ROLE_LECTURER");
});
const isStudent = computed(function () {
  const roles = store.getters.roles;
  return roles.includes("ROLE_STUDENT");
});
const hasWorks = computed(function () {
  return store.getters.works.length > 0;
});
const filteredWorks = computed(function () {
  const userId = store.getters.userId;
  const works = store.getters.works;
  return works.filter((work) => {
    if (isLecturer.value && work.userUuId.toString() === userId.toString()) {
      if (activeFilters.value.beforeDeadline && new Date(work.closeDate) >= new Date()) {
        return true;
      }
      if (activeFilters.value.afterDeadline && new Date(work.closeDate) < new Date()) {
        return true;
      }
    }
    if (isStudent.value && new Date(work.closeDate) >= new Date()) {
      // if (!work["submits"].some(w => w.userId.toString() === userId.toString())) {
      //   return true;
      // }
      return true;
    }
    return false;
  })
});

onMounted(async function () {
  await loadData();
});
</script>

<style scoped>
.button {
  text-align: center;
}
</style>
